precision mediump float;

varying highp vec2 textureCoordinate;
uniform sampler2D videoFrame;   //视频预览纹理
uniform sampler2D coverFrame;   //cover纹理
uniform int     _ispreview;     //是否预览图像
uniform int     _middletype;     //0：椭圆形，1：矩形
uniform vec2    _middlepoint;   //焦点中心
uniform vec2    _range;         //焦点区域横向和纵向的半径
uniform int     _type;           //特效类型
uniform int     _depthenable;    //是否打开景深处理,1为打开

vec4 _maskcolor = vec4(1.0,1.0,1.0,0.0);    //预览遮盖色彩
vec2 _framesize = vec2(480.0,320.0);        //完整区域


uniform vec2    _degree;         //角度,景深矩形区域偏转，尚未实现
//forst grass
vec4 forst(vec4 color,float intensity)
{
    
    float permain = 1.0 - intensity * 1.0;
    if(permain < 0.4)
    {
        permain = 0.1;
    }
    float perslave = (1.0 - permain)/16.0;    
    vec4 result = color * permain;
    vec2 pTmp;
    float dis = 0.002;
    
    pTmp = vec2(textureCoordinate.x,textureCoordinate.y+dis);
    result += texture2D(videoFrame,pTmp) * perslave * 1.0;
    pTmp = vec2(textureCoordinate.x+dis,textureCoordinate.y);
    result += texture2D(videoFrame,pTmp) * perslave * 1.0;
    pTmp = vec2(textureCoordinate.x-dis,textureCoordinate.y);
    result += texture2D(videoFrame,pTmp) * perslave * 1.0;
    pTmp = vec2(textureCoordinate.x,textureCoordinate.y-dis);
    result += texture2D(videoFrame,pTmp) * perslave * 1.0;

    pTmp = vec2(textureCoordinate.x+dis,textureCoordinate.y+dis);
    result += texture2D(videoFrame,pTmp) * perslave;
    pTmp = vec2(textureCoordinate.x-dis,textureCoordinate.y-dis);
    result += texture2D(videoFrame,pTmp) * perslave;
    pTmp = vec2(textureCoordinate.x+dis,textureCoordinate.y-dis);
    result += texture2D(videoFrame,pTmp) * perslave;
    pTmp = vec2(textureCoordinate.x-dis,textureCoordinate.y+dis);
    result += texture2D(videoFrame,pTmp) * perslave;

    pTmp = vec2(textureCoordinate.x,textureCoordinate.y+dis * 2.0);
    result += texture2D(videoFrame,pTmp) * perslave * 1.0;
    pTmp = vec2(textureCoordinate.x+dis * 2.0,textureCoordinate.y);
    result += texture2D(videoFrame,pTmp) * perslave * 1.0;
    pTmp = vec2(textureCoordinate.x-dis * 2.0,textureCoordinate.y);
    result += texture2D(videoFrame,pTmp) * perslave * 1.0;
    pTmp = vec2(textureCoordinate.x,textureCoordinate.y-dis * 2.0);
    result += texture2D(videoFrame,pTmp) * perslave * 1.0;
    
    pTmp = vec2(textureCoordinate.x+dis * 2.0,textureCoordinate.y+dis * 2.0);
    result += texture2D(videoFrame,pTmp) * perslave;
    pTmp = vec2(textureCoordinate.x-dis * 2.0,textureCoordinate.y-dis * 2.0);
    result += texture2D(videoFrame,pTmp) * perslave;
    pTmp = vec2(textureCoordinate.x+dis * 2.0,textureCoordinate.y-dis * 2.0);
    result += texture2D(videoFrame,pTmp) * perslave;
    pTmp = vec2(textureCoordinate.x-dis * 2.0,textureCoordinate.y+dis * 2.0);
    result += texture2D(videoFrame,pTmp) * perslave;

    
    
    result = result;
    return result;
}


vec4 coverForst(vec4 color)
{
    vec4 result = color;
    vec4 coverColor = texture2D(coverFrame,textureCoordinate);
    result = forst(result,0.2/*coverColor.a*/); 
    result = result * 0.6; 
    
//    if(coverColor.r > 0.5)
//    {
//        result = color;
//    } 
    
    return result;
    
}
/////////////////主程序////////////////////
void main()
{
    vec4 calculatedColor;
    calculatedColor = texture2D(videoFrame,textureCoordinate);
//    calculatedColor = coverForst(calculatedColor);
    calculatedColor = forst(calculatedColor,0.8);
    gl_FragColor = calculatedColor;
}
